/*
 * GUI.java
 *
 * Created on 11 stycze 2005, 12:02
 */

package jsampa;

import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Properties;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;

/**
 *
 * @author  michalus
 */
public class GUI extends javax.swing.JFrame {
    
    public SampaEngine se;
    
    /** Creates new form GUI */
    public GUI() {
        initComponents();
        
        this.setSize(300, 300);
        this.setVisible(true);        
        
        se = new SampaEngine();
        
        Properties ustawienia = new Properties();
        
        this.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e){
                Properties ustawienia = new Properties();
                
                try {
                    FileInputStream in = new FileInputStream("ustawienia.xml");
                    ustawienia.loadFromXML(in);
                    in.close();
                } catch(IOException eio) {
                    System.out.println("Ustawienia nie byy wczeniej zapisywane.");
                }
                
                try {
                    
                    ustawienia.setProperty("tekst", ""+jTextPane1.getText());
                    
//                    FileOutputStream out = new FileOutputStream("ustawienia");
//                    ustawienia.store(out, "Ustawienia programu");
//                    out.close();
                    
                    FileOutputStream out = new FileOutputStream("ustawienia.xml");
                    ustawienia.storeToXML(out, "Ustawienia programu");
                    out.close();
                    
                } catch(IOException eio) {
                    eio.printStackTrace();
                }
                
                System.exit(1);
            }
        });
        
        try {
            FileInputStream in = new FileInputStream("ustawienia.xml");
            ustawienia.loadFromXML(in);
            in.close();
            
        } catch(IOException e) {
            System.out.println("Ustawienia nie byy wczeniej zapisywane.");
        }
        
        jTextPane1.setText(ustawienia.getProperty("tekst", "Alibaba i czterdziestu rozbjnikw bujao si na lianie"));
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jTextPane1 = new javax.swing.JTextPane();
        jTextPane2 = new javax.swing.JTextPane();
        jMenuBar1 = new javax.swing.JMenuBar();
        menuFile = new javax.swing.JMenu();
        itemExit = new javax.swing.JMenuItem();
        menuTranskrypcja = new javax.swing.JMenu();
        itemTO = new javax.swing.JMenuItem();
        jSeparator1 = new javax.swing.JSeparator();
        itemTranskrybuj = new javax.swing.JMenuItem();
        itemOkienko = new javax.swing.JMenuItem();
        itemOdtworz = new javax.swing.JMenuItem();
        jSeparator2 = new javax.swing.JSeparator();
        itemReguly = new javax.swing.JMenuItem();
        menuOpcje = new javax.swing.JMenu();
        itemSciezka = new javax.swing.JMenuItem();
        jSeparator3 = new javax.swing.JSeparator();
        itemIntOzn = new javax.swing.JMenuItem();
        itemIntPyt = new javax.swing.JMenuItem();
        itemIntWykrz = new javax.swing.JMenuItem();
        jSeparator4 = new javax.swing.JSeparator();
        chckbOkienko = new javax.swing.JCheckBoxMenuItem();
        menuHelp = new javax.swing.JMenu();
        itemAbout = new javax.swing.JMenuItem();

        getContentPane().setLayout(new java.awt.GridLayout(2, 1, 5, 5));

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("JSampa - PFA");
        getContentPane().add(jTextPane1);

        getContentPane().add(jTextPane2);

        menuFile.setText("File");
        menuFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                menuFileActionPerformed(evt);
            }
        });

        itemExit.setMnemonic('x');
        itemExit.setText("Exit");
        itemExit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                itemExitActionPerformed(evt);
            }
        });

        menuFile.add(itemExit);

        jMenuBar1.add(menuFile);

        menuTranskrypcja.setText("Transkrypcja");
        itemTO.setText("Transkrybuj i Odtw\u00f3rz");
        itemTO.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                itemTOActionPerformed(evt);
            }
        });

        menuTranskrypcja.add(itemTO);

        menuTranskrypcja.add(jSeparator1);

        itemTranskrybuj.setMnemonic('t');
        itemTranskrybuj.setText("Transkrybuj");
        itemTranskrybuj.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                itemTranskrybujActionPerformed(evt);
            }
        });

        menuTranskrypcja.add(itemTranskrybuj);

        itemOkienko.setText("Okienko transkrybcji");
        itemOkienko.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                itemOkienkoActionPerformed(evt);
            }
        });

        menuTranskrypcja.add(itemOkienko);

        itemOdtworz.setMnemonic('o');
        itemOdtworz.setText("Odtw\u00f3rz");
        itemOdtworz.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                itemOdtworzActionPerformed(evt);
            }
        });

        menuTranskrypcja.add(itemOdtworz);

        menuTranskrypcja.add(jSeparator2);

        itemReguly.setMnemonic('r');
        itemReguly.setText("Regu\u0142y");
        itemReguly.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                itemRegulyActionPerformed(evt);
            }
        });

        menuTranskrypcja.add(itemReguly);

        jMenuBar1.add(menuTranskrypcja);

        menuOpcje.setText("Opcje");
        itemSciezka.setText("Zmie\u0144 \u015bcie\u017ck\u0119 do Mbroli");
        itemSciezka.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                itemSciezkaActionPerformed(evt);
            }
        });

        menuOpcje.add(itemSciezka);

        menuOpcje.add(jSeparator3);

        itemIntOzn.setText("Intonacja oznajmiaj\u0105ca");
        itemIntOzn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                itemIntOznActionPerformed(evt);
            }
        });

        menuOpcje.add(itemIntOzn);

        itemIntPyt.setText("Intonacja pytaj\u0105ca");
        itemIntPyt.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                itemIntPytActionPerformed(evt);
            }
        });

        menuOpcje.add(itemIntPyt);

        itemIntWykrz.setText("Intonacja wykrzyknikowa");
        itemIntWykrz.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                itemIntWykrzActionPerformed(evt);
            }
        });

        menuOpcje.add(itemIntWykrz);

        menuOpcje.add(jSeparator4);

        chckbOkienko.setText("Zawsze okienko transkrypcji");
        menuOpcje.add(chckbOkienko);

        jMenuBar1.add(menuOpcje);

        menuHelp.setText("Help");
        itemAbout.setMnemonic('a');
        itemAbout.setText("About");
        itemAbout.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                itemAboutActionPerformed(evt);
            }
        });

        menuHelp.add(itemAbout);

        jMenuBar1.add(menuHelp);

        setJMenuBar(jMenuBar1);

        pack();
    }//GEN-END:initComponents

    private void itemOkienkoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_itemOkienkoActionPerformed
        
        Transkrybowane t = se.transkrypcja(jTextPane1.getText());
        jTextPane2.setText(t.getString());
        t.write();        
        t.show();        
        
    }//GEN-LAST:event_itemOkienkoActionPerformed

    private void itemTOActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_itemTOActionPerformed
        
        Transkrybowane t = se.transkrypcja(jTextPane1.getText());
        jTextPane2.setText(t.getString());
        t.write();
        
        if(chckbOkienko.getState()) {
            t.show();
        }
        
        Properties ustawienia = new Properties();
        
        try {
            FileInputStream in = new FileInputStream("ustawienia.xml");
            ustawienia.loadFromXML(in);
            in.close();
        } catch(IOException e) {
            System.out.println("Ustawienia nie byy wczeniej zapisywane.");
        }
        
        try {          
                        
            String path = ustawienia.getProperty("path", "C:\\");            
            Process p = Runtime.getRuntime().exec(path+" sampa_output.pho");           
            
        } catch(IOException e) {
            e.printStackTrace();
        }
        
    }//GEN-LAST:event_itemTOActionPerformed

    private void itemIntWykrzActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_itemIntWykrzActionPerformed

        JFrame f = new JFrame();
        f.getContentPane().add(new IntonacjaPanel("intonacja_wykrzyknikowa"));
        f.setSize(500, 400);
        f.setTitle("Intonacja wykrzyknikowa");
        f.setVisible(true);
        
    }//GEN-LAST:event_itemIntWykrzActionPerformed

    private void itemIntPytActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_itemIntPytActionPerformed
        
        JFrame f = new JFrame();
        f.getContentPane().add(new IntonacjaPanel("intonacja_pytajaca"));
        f.setSize(500, 400);
        f.setTitle("Intonacja pytajca");
        f.setVisible(true);
        
    }//GEN-LAST:event_itemIntPytActionPerformed

    private void itemIntOznActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_itemIntOznActionPerformed

        JFrame f = new JFrame();
        f.getContentPane().add(new IntonacjaPanel("intonacja_oznajmujaca"));
        f.setSize(500, 400);
        f.setTitle("Intonacja oznajmujca");
        f.setVisible(true);
        
    }//GEN-LAST:event_itemIntOznActionPerformed

    private void itemSciezkaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_itemSciezkaActionPerformed
        
        Properties ustawienia = new Properties();
        
        try {
            FileInputStream in = new FileInputStream("ustawienia.xml");
            ustawienia.loadFromXML(in);
            in.close();
        } catch(IOException e) {
            System.out.println("Ustawienia nie byy wczeniej zapisywane.");
        }
        
        try {
            String oldpath = "C:\\";
            
            if(ustawienia.containsKey("path")) {
                oldpath = ustawienia.getProperty("path");
            }
            
            String path = JOptionPane.showInputDialog(null, "cieka do pakietu mbrola", oldpath);
            ustawienia.setProperty("path", path);
            
//            FileOutputStream out = new FileOutputStream("ustawienia");
//            ustawienia.store(out, "Ustawienia programu");
//            out.close();
            
            FileOutputStream out = new FileOutputStream("ustawienia.xml");
            ustawienia.storeToXML(out, "Ustawienia programu");
            out.close();
            
        } catch(IOException e) {
            e.printStackTrace();
        }
        
    }//GEN-LAST:event_itemSciezkaActionPerformed

    private void itemOdtworzActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_itemOdtworzActionPerformed
        
        Properties ustawienia = new Properties();
        
        try {
            FileInputStream in = new FileInputStream("ustawienia.xml");
            ustawienia.loadFromXML(in);
            in.close();
        } catch(IOException e) {
            System.out.println("Ustawienia nie byy wczeniej zapisywane.");
        }
        
        try {          
                        
            String path = ustawienia.getProperty("path", "C:\\");            
            Process p = Runtime.getRuntime().exec(path+" sampa_output.pho");           
            
        } catch(IOException e) {
            e.printStackTrace();
        }
        
    }//GEN-LAST:event_itemOdtworzActionPerformed

    private void itemRegulyActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_itemRegulyActionPerformed
//        JFrame f = new JFrame("Okno regu");
//        JScrollPane s = new JScrollPane(se.getPanel());        
//        f.setSize(300, 400);
//        f.getContentPane().add(s);
//        f.pack();
//        f.setVisible(true);
        
        JFrame f = new JFrame("Modyfikator regul");
        ModyfikatorRegul mr = new ModyfikatorRegul(se);
        f.getContentPane().add(mr); 
        f.setSize(500, 400);
        f.setVisible(true);
        
    }//GEN-LAST:event_itemRegulyActionPerformed

    private void itemTranskrybujActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_itemTranskrybujActionPerformed
        Transkrybowane t = se.transkrypcja(jTextPane1.getText());
        jTextPane2.setText(t.getString());
        t.write();
        
        if(chckbOkienko.getState()) {
            t.show();
        }
    }//GEN-LAST:event_itemTranskrybujActionPerformed

    private void itemAboutActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_itemAboutActionPerformed
        JOptionPane.showMessageDialog(null, "Micha Maecki\ns2585@pjwstk.edu.pl\nProjekt PFA 2005", "About", JOptionPane.INFORMATION_MESSAGE);
    }//GEN-LAST:event_itemAboutActionPerformed

    private void itemExitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_itemExitActionPerformed
        Properties ustawienia = new Properties();
        
        try {
            FileInputStream in = new FileInputStream("ustawienia.xml");
            ustawienia.loadFromXML(in);
            in.close();
        } catch(IOException e) {
            System.out.println("Ustawienia nie byy wczeniej zapisywane.");
        }
        
        try {           
            
            ustawienia.setProperty("tekst", ""+jTextPane1.getText());
            
//            FileOutputStream out = new FileOutputStream("ustawienia");
//            ustawienia.store(out, "Ustawienia programu");            
//            out.close();
            
            FileOutputStream out = new FileOutputStream("ustawienia.xml");
            ustawienia.storeToXML(out, "Ustawienia programu");
            out.close();
            
        } catch(IOException e) {
            e.printStackTrace();
        }
        
        System.exit(1);
    }//GEN-LAST:event_itemExitActionPerformed

    private void menuFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_menuFileActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_menuFileActionPerformed
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new GUI().setVisible(true);
            }
        });
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBoxMenuItem chckbOkienko;
    private javax.swing.JMenuItem itemAbout;
    private javax.swing.JMenuItem itemExit;
    private javax.swing.JMenuItem itemIntOzn;
    private javax.swing.JMenuItem itemIntPyt;
    private javax.swing.JMenuItem itemIntWykrz;
    private javax.swing.JMenuItem itemOdtworz;
    private javax.swing.JMenuItem itemOkienko;
    private javax.swing.JMenuItem itemReguly;
    private javax.swing.JMenuItem itemSciezka;
    private javax.swing.JMenuItem itemTO;
    private javax.swing.JMenuItem itemTranskrybuj;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JSeparator jSeparator2;
    private javax.swing.JSeparator jSeparator3;
    private javax.swing.JSeparator jSeparator4;
    private javax.swing.JTextPane jTextPane1;
    private javax.swing.JTextPane jTextPane2;
    private javax.swing.JMenu menuFile;
    private javax.swing.JMenu menuHelp;
    private javax.swing.JMenu menuOpcje;
    private javax.swing.JMenu menuTranskrypcja;
    // End of variables declaration//GEN-END:variables
    
}
